## yosys 0.23

=== Makefile ===

CONFIG := clang
# CONFIG := gcc
# CONFIG := gcc-4.8
# CONFIG := afl-gcc
# CONFIG := emcc
# CONFIG := wasi
# CONFIG := mxe
# CONFIG := msys2-32
# CONFIG := msys2-64

# features (the more the better)
ENABLE_TCL := 1
ENABLE_ABC := 1
ENABLE_GLOB := 1
ENABLE_PLUGINS := 1
ENABLE_READLINE := 1
ENABLE_EDITLINE := 0
ENABLE_GHDL := 0
ENABLE_VERIFIC := 0
ENABLE_VERIFIC_EDIF := 0
ENABLE_VERIFIC_LIBERTY := 0
DISABLE_VERIFIC_EXTENSIONS := 0
DISABLE_VERIFIC_VHDL := 0
ENABLE_COVER := 1
ENABLE_LIBYOSYS := 0
ENABLE_ZLIB := 1

# python wrappers
ENABLE_PYOSYS := 0

# other configuration flags
ENABLE_GCOV := 0
ENABLE_GPROF := 0
ENABLE_DEBUG := 0
ENABLE_NDEBUG := 0
ENABLE_CCACHE := 0
# sccache is not always a drop-in replacement for ccache in practice
ENABLE_SCCACHE := 0
LINK_CURSES := 0
LINK_TERMCAP := 0
LINK_ABC := 0
# Needed for environments that can't run executables (i.e. emscripten, wasm)
DISABLE_SPAWN := 0
# Needed for environments that don't have proper thread support (i.e. emscripten, wasm--for now)
DISABLE_ABC_THREADS := 0

# clang sanitizers
SANITIZER =
# SANITIZER = address
# SANITIZER = memory
# SANITIZER = undefined
# SANITIZER = cfi

PROGRAM_PREFIX :=

OS := $(shell uname -s)
PREFIX ?= /usr/local
INSTALL_SUDO :=
ifneq ($(filter MINGW%,$(OS)),)
OS := MINGW
endif

ifneq ($(wildcard Makefile.conf),)
include Makefile.conf
endif

ifeq ($(ENABLE_PYOSYS),1)
ENABLE_LIBYOSYS := 1
endif

BINDIR := $(PREFIX)/bin
LIBDIR := $(PREFIX)/lib/$(PROGRAM_PREFIX)yosys
DATDIR := $(PREFIX)/share/$(PROGRAM_PREFIX)yosys

EXE =
OBJS =
GENFILES =
EXTRA_OBJS =
EXTRA_TARGETS =
TARGETS = $(PROGRAM_PREFIX)yosys$(EXE) $(PROGRAM_PREFIX)yosys-config

PRETTY = 1
SMALL = 0

# Unit test
UNITESTPATH := tests/unit

all: top-all

YOSYS_SRC := $(dir $(firstword $(MAKEFILE_LIST)))
VPATH := $(YOSYS_SRC)

CXXSTD ?= c++11
CXXFLAGS := $(CXXFLAGS) -Wall -Wextra -ggdb -I. -I"$(YOSYS_SRC)" -MD -MP -D_YOSYS_ -fPIC -I$(PREFIX)/include
LDLIBS := $(LDLIBS) -lstdc++ -lm
PLUGIN_LDFLAGS :=
PLUGIN_LDLIBS :=
EXE_LDFLAGS :=
ifeq ($(OS), MINGW)
EXE_LDFLAGS := -Wl,--export-all-symbols -Wl,--out-implib,libyosys_exe.a
PLUGIN_LDFLAGS += -L"$(LIBDIR)"
PLUGIN_LDLIBS := -lyosys_exe
endif

PKG_CONFIG ?= pkg-config
SED ?= sed
BISON ?= bison
STRIP ?= strip
AWK ?= awk

ifeq ($(OS), Darwin)
PLUGIN_LDFLAGS += -undefined dynamic_lookup

# homebrew search paths
ifneq ($(shell :; command -v brew),)
BREW_PREFIX := $(shell brew --prefix)/opt
$(info $$BREW_PREFIX is [${BREW_PREFIX}])
ifeq ($(ENABLE_PYOSYS),1)
CXXFLAGS += -I$(BREW_PREFIX)/boost/include/boost
LDFLAGS += -L$(BREW_PREFIX)/boost/lib
endif
CXXFLAGS += -I$(BREW_PREFIX)/readline/include
LDFLAGS += -L$(BREW_PREFIX)/readline/lib
PKG_CONFIG_PATH := $(BREW_PREFIX)/libffi/lib/pkgconfig:$(PKG_CONFIG_PATH)
PKG_CONFIG_PATH := $(BREW_PREFIX)/tcl-tk/lib/pkgconfig:$(PKG_CONFIG_PATH)
export PATH := $(BREW_PREFIX)/bison/bin:$(BREW_PREFIX)/gettext/bin:$(BREW_PREFIX)/flex/bin:$(PATH)

# macports search paths
else ifneq ($(shell :; command -v port),)
PORT_PREFIX := $(patsubst %/bin/port,%,$(shell :; command -v port))
CXXFLAGS += -I$(PORT_PREFIX)/include
LDFLAGS += -L$(PORT_PREFIX)/lib
PKG_CONFIG_PATH := $(PORT_PREFIX)/lib/pkgconfig:$(PKG_CONFIG_PATH)
export PATH := $(PORT_PREFIX)/bin:$(PATH)
endif

else
LDFLAGS += -rdynamic
ifneq ($(OS), OpenBSD)
LDLIBS += -lrt
endif
endif

YOSYS_VER := 0.23

# Note: We arrange for .gitcommit to contain the (short) commit hash in
# tarballs generated with git-archive(1) using .gitattributes. The git repo
# will have this file in its unexpanded form tough, in which case we fall
# back to calling git directly.
TARBALL_GIT_REV := $(shell cat $(YOSYS_SRC)/.gitcommit)
ifeq ($(TARBALL_GIT_REV),$$Format:%h$$)
GIT_REV := $(shell git ls-remote $(YOSYS_SRC) HEAD -q | $(AWK) 'BEGIN {R = "UNKNOWN"}; ($$2 == "HEAD") {R = substr($$1, 1, 9); exit} END {print R}')
else
GIT_REV := $(TARBALL_GIT_REV)
endif

OBJS = kernel/version_$(GIT_REV).o

bumpversion:
#	sed -i "/^YOSYS_VER := / s/+[0-9][0-9]*$$/+`git log --oneline f109fa3.. | wc -l`/;" Makefile

# set 'ABCREV = default' to use abc/ as it is
#
# Note: If you do ABC development, make sure that 'abc' in this directory
# is just a symlink to your actual ABC working directory, as 'make mrproper'
# will remove the 'abc' directory and you do not want to accidentally
# delete your work on ABC..
ABCREV = ab5b16e
ABCPULL = 1
ABCURL ?= https://github.com/YosysHQ/abc
ABCMKARGS = CC="$(CXX)" CXX="$(CXX)" ABC_USE_LIBSTDCXX=1 ABC_USE_NAMESPACE=abc VERBOSE=$(Q)

# set ABCEXTERNAL = <abc-command> to use an external ABC instance
# Note: The in-tree ABC (yosys-abc) will not be installed when ABCEXTERNAL is set.
ABCEXTERNAL ?=

define newline


endef

ifneq ($(wildcard Makefile.conf),)
# don't echo Makefile.conf contents when invoked to print source versions
ifeq ($(findstring echo-,$(MAKECMDGOALS)),)
$(info $(subst $$--$$,$(newline),$(shell sed 's,^,[Makefile.conf] ,; s,$$,$$--$$,;' < Makefile.conf | tr -d '\n' | sed 's,\$$--\$$$$,,')))
endif
include Makefile.conf
endif

PYTHON_EXECUTABLE := $(shell if python3 -c ""; then echo "python3"; else echo "python"; fi)
ifeq ($(ENABLE_PYOSYS),1)
PYTHON_VERSION_TESTCODE := "import sys;t='{v[0]}.{v[1]}'.format(v=list(sys.version_info[:2]));print(t)"
PYTHON_VERSION := $(shell $(PYTHON_EXECUTABLE) -c ""$(PYTHON_VERSION_TESTCODE)"")
PYTHON_MAJOR_VERSION := $(shell echo $(PYTHON_VERSION) | cut -f1 -d.)

ENABLE_PYTHON_CONFIG_EMBED ?= $(shell $(PYTHON_EXECUTABLE)-config --embed --libs > /dev/null && echo 1)
ifeq ($(ENABLE_PYTHON_CONFIG_EMBED),1)
PYTHON_CONFIG := $(PYTHON_EXECUTABLE)-config --embed
else
PYTHON_CONFIG := $(PYTHON_EXECUTABLE)-config
endif

PYTHON_DESTDIR := $(shell $(PYTHON_EXECUTABLE) -c "import site; print(site.getsitepackages()[-1]);")

# Reload Makefile.conf to override python specific variables if defined
ifneq ($(wildcard Makefile.conf),)
include Makefile.conf
endif

endif

ABC_ARCHFLAGS = ""
ifeq ($(OS), OpenBSD)
ABC_ARCHFLAGS += "-DABC_NO_RLIMIT"
endif

ifeq ($(CONFIG),clang)
CXX = clang
LD = clang++
CXXFLAGS += -std=$(CXXSTD) -Os
ABCMKARGS += ARCHFLAGS="-DABC_USE_STDINT_H -Wno-c++11-narrowing $(ABC_ARCHFLAGS)"

ifneq ($(SANITIZER),)
$(info [Clang Sanitizer] $(SANITIZER))
CXXFLAGS += -g -O1 -fno-omit-frame-pointer -fno-optimize-sibling-calls -fsanitize=$(SANITIZER)
LDFLAGS += -g -fsanitize=$(SANITIZER)
ifneq ($(findstring address,$(SANITIZER)),)
ENABLE_COVER := 0
endif
ifneq ($(findstring memory,$(SANITIZER)),)
CXXFLAGS += -fPIE -fsanitize-memory-track-origins
LDFLAGS += -fPIE -fsanitize-memory-track-origins
endif
ifneq ($(findstring cfi,$(SANITIZER)),)
CXXFLAGS += -flto
LDFLAGS += -flto
endif
endif

else ifeq ($(CONFIG),gcc)
CXX = gcc
LD = gcc
CXXFLAGS += -std=$(CXXSTD) -Os
ABCMKARGS += ARCHFLAGS="-DABC_USE_STDINT_H $(ABC_ARCHFLAGS)"

else ifeq ($(CONFIG),gcc-static)
LD = $(CXX)
LDFLAGS := $(filter-out -rdynamic,$(LDFLAGS)) -static
LDLIBS := $(filter-out -lrt,$(LDLIBS))
CXXFLAGS := $(filter-out -fPIC,$(CXXFLAGS))
CXXFLAGS += -std=$(CXXSTD) -Os
ABCMKARGS = CC="$(CC)" CXX="$(CXX)" LD="$(LD)" ABC_USE_LIBSTDCXX=1 LIBS="-lm -lpthread -static" OPTFLAGS="-O" \
                       ARCHFLAGS="-DABC_USE_STDINT_H -DABC_NO_DYNAMIC_LINKING=1 -Wno-unused-but-set-variable $(ARCHFLAGS)" ABC_USE_NO_READLINE=1
ifeq ($(DISABLE_ABC_THREADS),1)
ABCMKARGS += "ABC_USE_NO_PTHREADS=1"
endif

else ifeq ($(CONFIG),gcc-4.8)
CXX = gcc-4.8
LD = gcc-4.8
CXXFLAGS += -std=$(CXXSTD) -Os
ABCMKARGS += ARCHFLAGS="-DABC_USE_STDINT_H"

else ifeq ($(CONFIG),afl-gcc)
CXX = AFL_QUIET=1 AFL_HARDEN=1 afl-gcc
LD = AFL_QUIET=1 AFL_HARDEN=1 afl-gcc
CXXFLAGS += -std=$(CXXSTD) -Os
ABCMKARGS += ARCHFLAGS="-DABC_USE_STDINT_H"

else ifeq ($(CONFIG),cygwin)
CXX = gcc
LD = gcc
CXXFLAGS += -std=gnu++11 -Os
ABCMKARGS += ARCHFLAGS="-DABC_USE_STDINT_H"

else ifeq ($(CONFIG),emcc)
CXX = emcc
LD = emcc
CXXFLAGS := -std=$(CXXSTD) $(filter-out -fPIC -ggdb,$(CXXFLAGS))
ABCMKARGS += ARCHFLAGS="-DABC_USE_STDINT_H -DABC_MEMALIGN=8 -Wno-c++11-narrowing"
EMCC_CXXFLAGS := -Os -Wno-warn-absolute-paths
EMCC_LDFLAGS := --memory-init-file 0 --embed-file share
EMCC_LDFLAGS += -s NO_EXIT_RUNTIME=1
EMCC_LDFLAGS += -s EXPORTED_FUNCTIONS="['_main','_run','_prompt','_errmsg','_memset']"
EMCC_LDFLAGS += -s TOTAL_MEMORY=134217728
EMCC_LDFLAGS += -s EXPORTED_RUNTIME_METHODS='["ccall", "cwrap"]'
# https://github.com/kripken/emscripten/blob/master/src/settings.js
CXXFLAGS += $(EMCC_CXXFLAGS)
LDFLAGS += $(EMCC_LDFLAGS)
LDLIBS =
EXE = .js

DISABLE_SPAWN := 1

TARGETS := $(filter-out $(PROGRAM_PREFIX)yosys-config,$(TARGETS))
EXTRA_TARGETS += yosysjs-$(YOSYS_VER).zip

ifeq ($(ENABLE_ABC),1)
LINK_ABC := 1
DISABLE_ABC_THREADS := 1
endif

viz.js:
	wget -O viz.js.part https://github.com/mdaines/viz.js/releases/download/0.0.3/viz.js
	mv viz.js.part viz.js

yosysjs-$(YOSYS_VER).zip: yosys.js viz.js misc/yosysjs/*
	rm -rf yosysjs-$(YOSYS_VER) yosysjs-$(YOSYS_VER).zip
	mkdir -p yosysjs-$(YOSYS_VER)
	cp viz.js misc/yosysjs/* yosys.js yosys.wasm yosysjs-$(YOSYS_VER)/
	zip -r yosysjs-$(YOSYS_VER).zip yosysjs-$(YOSYS_VER)

yosys.html: misc/yosys.html
	$(P) cp misc/yosys.html yosys.html

else ifeq ($(CONFIG),wasi)
ifeq ($(WASI_SDK),)
CXX = clang
LD = clang++
AR = llvm-ar
RANLIB = llvm-ranlib
WASIFLAGS := -target wasm32-wasi --sysroot $(WASI_SYSROOT) $(WASIFLAGS)
else
CXX = $(WASI_SDK)/bin/clang
LD = $(WASI_SDK)/bin/clang++
AR = $(WASI_SDK)/bin/ar
RANLIB = $(WASI_SDK)/bin/ranlib
WASIFLAGS := --sysroot $(WASI_SDK)/share/wasi-sysroot $(WASIFLAGS)
endif
CXXFLAGS := $(WASIFLAGS) -std=$(CXXSTD) -Os $(filter-out -fPIC,$(CXXFLAGS))
LDFLAGS := $(WASIFLAGS) -Wl,-z,stack-size=1048576 $(filter-out -rdynamic,$(LDFLAGS))
LDLIBS := $(filter-out -lrt,$(LDLIBS))
ABCMKARGS += AR="$(AR)" RANLIB="$(RANLIB)"
ABCMKARGS += ARCHFLAGS="$(WASIFLAGS) -DABC_USE_STDINT_H -DABC_NO_DYNAMIC_LINKING -DABC_NO_RLIMIT -Wno-c++11-narrowing"
ABCMKARGS += OPTFLAGS="-Os"
EXE = .wasm

DISABLE_SPAWN := 1

ifeq ($(ENABLE_ABC),1)
LINK_ABC := 1
DISABLE_ABC_THREADS := 1
endif

else ifeq ($(CONFIG),mxe)
PKG_CONFIG = /usr/local/src/mxe/usr/bin/i686-w64-mingw32.static-pkg-config
CXX = /usr/local/src/mxe/usr/bin/i686-w64-mingw32.static-g++
LD = /usr/local/src/mxe/usr/bin/i686-w64-mingw32.static-g++
CXXFLAGS += -std=$(CXXSTD) -Os -D_POSIX_SOURCE -DYOSYS_MXE_HACKS -Wno-attributes
CXXFLAGS := $(filter-out -fPIC,$(CXXFLAGS))
LDFLAGS := $(filter-out -rdynamic,$(LDFLAGS)) -s
LDLIBS := $(filter-out -lrt,$(LDLIBS))
ABCMKARGS += ARCHFLAGS="-DWIN32_NO_DLL -DHAVE_STRUCT_TIMESPEC -fpermissive -w"
# TODO: Try to solve pthread linking issue in more appropriate way
ABCMKARGS += LIBS="lib/x86/pthreadVC2.lib -s" LDFLAGS="-Wl,--allow-multiple-definition" ABC_USE_NO_READLINE=1 CC="/usr/local/src/mxe/usr/bin/i686-w64-mingw32.static-gcc"
EXE = .exe

else ifeq ($(CONFIG),msys2-32)
CXX = i686-w64-mingw32-g++
LD = i686-w64-mingw32-g++
CXXFLAGS += -std=$(CXXSTD) -Os -D_POSIX_SOURCE -DYOSYS_WIN32_UNIX_DIR
CXXFLAGS := $(filter-out -fPIC,$(CXXFLAGS))
LDFLAGS := $(filter-out -rdynamic,$(LDFLAGS)) -s
LDLIBS := $(filter-out -lrt,$(LDLIBS))
ABCMKARGS += ARCHFLAGS="-DABC_USE_STDINT_H -DWIN32_NO_DLL -DHAVE_STRUCT_TIMESPEC -fpermissive -w"
ABCMKARGS += LIBS="-lpthread -s" ABC_USE_NO_READLINE=0 CC="i686-w64-mingw32-gcc" CXX="$(CXX)"
EXE = .exe

else ifeq ($(CONFIG),msys2-64)
CXX = x86_64-w64-mingw32-g++
LD = x86_64-w64-mingw32-g++
CXXFLAGS += -std=$(CXXSTD) -Os -D_POSIX_SOURCE -DYOSYS_WIN32_UNIX_DIR
CXXFLAGS := $(filter-out -fPIC,$(CXXFLAGS))
LDFLAGS := $(filter-out -rdynamic,$(LDFLAGS)) -s
LDLIBS := $(filter-out -lrt,$(LDLIBS))
ABCMKARGS += ARCHFLAGS="-DABC_USE_STDINT_H -DWIN32_NO_DLL -DHAVE_STRUCT_TIMESPEC -fpermissive -w"
ABCMKARGS += LIBS="-lpthread -s" ABC_USE_NO_READLINE=0 CC="x86_64-w64-mingw32-gcc" CXX="$(CXX)"
EXE = .exe

else ifneq ($(CONFIG),none)
$(error Invalid CONFIG setting '$(CONFIG)'. Valid values: clang, gcc, gcc-4.8, emcc, mxe, msys2-32, msys2-64)
endif

ifeq ($(ENABLE_LIBYOSYS),1)
TARGETS += libyosys.so
endif

ifeq ($(ENABLE_PYOSYS),1)

=== examples/smtbmc/Makefile ===

all: demo1 demo2 demo3 demo4 demo5 demo6 demo7 demo8 demo9 glift_mux

demo1: demo1.smt2
	yosys-smtbmc --dump-vcd demo1.vcd demo1.smt2
	yosys-smtbmc -i --dump-vcd demo1.vcd demo1.smt2

demo2: demo2.smt2
	yosys-smtbmc -g --dump-vcd demo2.vcd --dump-smtc demo2.smtc --dump-vlogtb demo2_tb.v demo2.smt2
	iverilog -g2012 -o demo2_tb demo2_tb.v demo2.v
	vvp demo2_tb +vcd=demo2_tb.vcd

demo3: demo3.smt2
	yosys-smtbmc --dump-vcd demo3.vcd --smtc demo3.smtc demo3.smt2

demo4: demo4.smt2
	yosys-smtbmc -s yices --dump-vcd demo4.vcd --smtc demo4.smtc demo4.smt2

demo5: demo5.smt2
	yosys-smtbmc -g -t 50 --dump-vcd demo5.vcd demo5.smt2

demo6: demo6.smt2
	yosys-smtbmc -t 1 demo6.smt2

demo7: demo7.smt2
	yosys-smtbmc -t 10 demo7.smt2

demo8: demo8.smt2
	yosys-smtbmc -s z3 -t 1 -g demo8.smt2

demo9: demo9.smt2
	yosys-smtbmc -s z3 -t 1 -g demo9.smt2

glift_mux:
	yosys -ql glift_mux.yslog glift/mux2.ys

demo1.smt2: demo1.v
	yosys -ql demo1.yslog -p 'read_verilog -formal demo1.v; prep -top demo1 -nordff; write_smt2 -wires demo1.smt2'

demo2.smt2: demo2.v
	yosys -ql demo2.yslog -p 'read_verilog -formal demo2.v; prep -top demo2 -nordff; write_smt2 -wires demo2.smt2'

demo3.smt2: demo3.v
	yosys -ql demo3.yslog -p 'read_verilog -formal demo3.v; prep -top demo3 -nordff; write_smt2 -wires demo3.smt2'

demo4.smt2: demo4.v
	yosys -ql demo4.yslog -p 'read_verilog -formal demo4.v; prep -top demo4 -nordff; write_smt2 -wires demo4.smt2'

demo5.smt2: demo5.v
	yosys -ql demo5.yslog -p 'read_verilog -formal demo5.v; prep -top demo5 -nordff; write_smt2 -wires demo5.smt2'

demo6.smt2: demo6.v
	yosys -ql demo6.yslog -p 'read_verilog demo6.v; prep -top demo6 -nordff; assertpmux; opt -keepdc -fast; write_smt2 -wires demo6.smt2'

demo7.smt2: demo7.v
	yosys -ql demo7.yslog -p 'read_verilog -formal demo7.v; prep -top demo7 -nordff; write_smt2 -wires demo7.smt2'

demo8.smt2: demo8.v
	yosys -ql demo8.yslog -p 'read_verilog -formal demo8.v; prep -top demo8 -nordff; write_smt2 -stbv -wires demo8.smt2'

demo9.smt2: demo9.v
	yosys -ql demo9.yslog -p 'read_verilog -formal demo9.v; prep -top demo9 -nordff; write_smt2 -stbv -wires demo9.smt2'

clean:
	rm -f demo1.yslog demo1.smt2 demo1.vcd
	rm -f demo2.yslog demo2.smt2 demo2.vcd demo2.smtc demo2_tb.v demo2_tb demo2_tb.vcd
	rm -f demo3.yslog demo3.smt2 demo3.vcd
	rm -f demo4.yslog demo4.smt2 demo4.vcd
	rm -f demo5.yslog demo5.smt2 demo5.vcd
	rm -f demo6.yslog demo6.smt2
	rm -f demo7.yslog demo7.smt2
	rm -f demo8.yslog demo8.smt2
	rm -f demo9.yslog demo9.smt2
	rm -f glift_mux.ys

.PHONY: demo1 demo2 demo3 demo4 demo5 demo6 demo7 demo8 demo9 clean

=== libs/ezsat/Makefile ===

CC = clang
CXX = clang
CXXFLAGS = -MD -Wall -Wextra -ggdb
CXXFLAGS += -std=c++11 -O0
LDLIBS = ../minisat/Options.cc ../minisat/SimpSolver.cc ../minisat/Solver.cc ../minisat/System.cc -lm -lstdc++


all: demo_vec demo_bit demo_cmp testbench puzzle3d

demo_vec: demo_vec.o ezsat.o ezminisat.o
demo_bit: demo_bit.o ezsat.o ezminisat.o
demo_cmp: demo_cmp.o ezsat.o ezminisat.o
testbench: testbench.o ezsat.o ezminisat.o
puzzle3d: puzzle3d.o ezsat.o ezminisat.o

test: all
	./testbench
	./demo_bit
	./demo_vec
	# ./demo_cmp
	# ./puzzle3d

clean:
	rm -f demo_bit demo_vec demo_cmp testbench puzzle3d *.o *.d

.PHONY: all test clean

-include *.d

=== libs/subcircuit/Makefile ===

CONFIG := clang-debug
# CONFIG := gcc-debug
# CONFIG := profile
# CONFIG := release

CC = clang
CXX = clang
CXXFLAGS = -MD -Wall -Wextra -ggdb
LDLIBS = -lstdc++

ifeq ($(CONFIG),clang-debug)
CXXFLAGS += -std=c++11 -O0
endif

ifeq ($(CONFIG),gcc-debug)
CC = gcc
CXX = gcc
CXXFLAGS += -std=gnu++0x -O0
endif

ifeq ($(CONFIG),profile)
CC = gcc
CXX = gcc
CXXFLAGS += -std=gnu++0x -Os -DNDEBUG
endif

ifeq ($(CONFIG),release)
CC = gcc
CXX = gcc
CXXFLAGS += -std=gnu++0x -march=native -O3 -DNDEBUG
endif

all: demo scshell

demo: demo.o subcircuit.o

scshell: scshell.o subcircuit.o

test: scshell
	./scshell < test_macc22.txt
	./scshell < test_mine.txt
	perl test_perm.pl | ./scshell
	splrun test_shorts.spl | ./scshell
	splrun test_large.spl | ./scshell

clean:
	rm -f demo scshell *.o *.d

.PHONY: all test clean

-include *.d

=== manual/PRESENTATION_ExSyn/Makefile ===

TARGETS += proc_01 proc_02 proc_03
TARGETS += opt_01 opt_02 opt_03 opt_04
TARGETS += memory_01 memory_02
TARGETS += techmap_01
TARGETS += abc_01

all: $(addsuffix .pdf,$(TARGETS))

define make_pdf_template
$(1).pdf: $(1)*.v $(1)*.ys
	../../yosys -p 'script $(1).ys; show -notitle -prefix $(1) -format pdf'
endef

$(foreach trg,$(TARGETS),$(eval $(call make_pdf_template,$(trg))))

clean:
	rm -f $(addsuffix .pdf,$(TARGETS))
	rm -f $(addsuffix .dot,$(TARGETS))

=== manual/PRESENTATION_Prog/Makefile ===

all: test0.log test1.log test2.log

CXXFLAGS=$(shell ../../yosys-config --cxxflags)
DATDIR=$(shell ../../yosys-config --datdir)

my_cmd.so: my_cmd.cc
	../../yosys-config --exec --cxx $(subst $(DATDIR),../../share,$(CXXFLAGS)) --ldflags -o my_cmd.so -shared my_cmd.cc --ldlibs

test0.log: my_cmd.so
	../../yosys -Ql test0.log_new -m ./my_cmd.so -p 'my_cmd foo bar' absval_ref.v
	mv test0.log_new test0.log

test1.log: my_cmd.so
	../../yosys -Ql test1.log_new -m ./my_cmd.so -p 'clean; test1; dump' absval_ref.v
	mv test1.log_new test1.log

test2.log: my_cmd.so
	../../yosys -Ql test2.log_new -m ./my_cmd.so -p 'hierarchy -top test; test2' sigmap_test.v
	mv test2.log_new test2.log

=== debian/changelog ===
yosys (0.23-6) unstable; urgency=medium

  * Fix autotest error patch
  * Require berkeley-abc 1.01+20221019git70cb339+dfsg-3 to fix armhf

 -- Daniel Gröber <dxld@darkboxed.org>  Sat, 03 Dec 2022 23:15:20 +0100

yosys (0.23-5) unstable; urgency=medium

  * Add patch to be verbose on test errors
  * Allow fast unclean rebuild

 -- Daniel Gröber <dxld@darkboxed.org>  Sat, 03 Dec 2022 03:23:09 +0100

yosys (0.23-4) unstable; urgency=medium

  * Fix fstGetUint32 crash on mips64el, Thanks Scott Ashcroft

 -- Daniel Gröber <dxld@darkboxed.org>  Fri, 02 Dec 2022 15:57:26 +0100

yosys (0.23-3) unstable; urgency=medium

  * Add patch to fix blhc CLFAGS warning
  * Fix d/rules sh syntax

 -- Daniel Gröber <dxld@darkboxed.org>  Sun, 13 Nov 2022 23:34:50 +0100

yosys (0.23-1) unstable; urgency=medium

  * New upstream version 0.23
  * Refresh patches

 -- Daniel Gröber <dxld@darkboxed.org>  Sun, 13 Nov 2022 13:48:22 +0100

yosys (0.22-1) unstable; urgency=medium

  * Revise big-endian arch exclude mechanism
  * Fix debian/watch
  * New upstream version 0.22

 -- Daniel Gröber <dxld@darkboxed.org>  Sun, 30 Oct 2022 01:27:23 +0200

=== debian/control ===
Source: yosys
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Ruben Undheim <ruben.undheim@gmail.com>,
           Sebastian Kuzminsky <seb@highlab.com>,
           Daniel Gröber <dxld@darkboxed.org>
Section: electronics
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-python,
               tcl-dev,
               libreadline-dev,
               bison,
               flex,
               gawk,
               libffi-dev,
               pkg-config,
               txt2man,
               iverilog (>= 10.1),
               python3,
               berkeley-abc (>= 1.01+20221019git70cb339+dfsg-3)
Build-Depends-Indep:
               texlive-base,
               texlive-plain-generic,
               texlive-fonts-recommended,
               texlive-fonts-extra,
               texlive-latex-base,
               texlive-latex-extra,
               texlive-font-utils,
               texlive-science,
               texlive-publishers,
               texlive-bibtex-extra,
               lmodern,
               graphviz
Rules-Requires-Root: no
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/science-team/yosys
Vcs-Git: https://salsa.debian.org/science-team/yosys.git
Homepage: https://github.com/YosysHQ/yosys

Package: yosys
Architecture: any
Depends: ${shlibs:Depends},
         ${python3:Depends},
         python3-click,
         ${misc:Depends},
         berkeley-abc (>= 1.01+20221019git70cb339+dfsg-3),
         xdot
Description: Framework for Verilog RTL synthesis
 This is a framework for Verilog RTL synthesis. It currently has extensive
 Verilog-2005 support and provides a basic set of synthesis algorithms for
 various application domains.
 .
 Yosys can be adapted to perform any synthesis job by combining the existing
 passes (algorithms) using synthesis scripts and adding additional passes as
 needed by extending the yosys C++ code base.

Package: yosys-dev
Architecture: any
Depends: ${shlibs:Depends},
         ${python3:Depends},
         ${misc:Depends},
         tcl-dev,
         libffi-dev,
         libreadline-dev
Description: Framework for Verilog RTL synthesis (development files)
 Yosys is a framework for Verilog RTL synthesis. It currently has extensive
 Verilog-2005 support and provides a basic set of synthesis algorithms for
 various application domains.
 .
 Yosys can be adapted to perform any synthesis job by combining the existing
 passes (algorithms) using synthesis scripts and adding additional passes as
 needed by extending the yosys C++ code base.
 .
 This package contains the headers and programs needed to build yosys plugins.

Package: yosys-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Multi-Arch: foreign
Suggests: yosys
Description: Documentation for Yosys
 Yosys is a framework for Verilog RTL synthesis. It currently has extensive
 Verilog-2005 support and provides a basic set of synthesis algorithms for
 various application domains.
 .
 Yosys can be adapted to perform any synthesis job by combining the existing
 passes (algorithms) using synthesis scripts and adding additional passes as
 needed by extending the yosys C++ code base.
 .
 This package contains the manual.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/pkg-info.mk

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

PDF_DATE   :=     $(shell LC_ALL=C date -u -d @$(SOURCE_DATE_EPOCH) +D:%Y%m%d%H%M%SZ)
PDF_DATE2  :=     $(shell LC_ALL=C date -u -d @$(SOURCE_DATE_EPOCH) +"%B %d, %Y")
CHANGELOG_DATE ?= $(shell LC_ALL=C date -u -d @$(SOURCE_DATE_EPOCH) +"%d %B %Y")

%:
	PREFIX=/usr dh $@ --with=python3

override_dh_auto_clean:
	dh_auto_clean
	$(RM) debian/man/*.1
	$(RM) Makefile.conf

override_dh_auto_configure:
	printf '%s\n' \
	  'CONFIG := gcc' \
	  'ABCEXTERNAL=berkeley-abc' \
	  'ABCPULL=0' \
	  'STRIP=:' \
	  > Makefile.conf

override_dh_auto_install:
	dh_auto_install
	chmod a-x debian/tmp/usr/share/yosys/achronix/speedster22i/cells*.v

override_dh_installman:
	cd debian/man ; CHANGELOG_DATE="$(CHANGELOG_DATE)" ./genmanpages.sh
	dh_installman

override_dh_compress:
	dh_compress --exclude=.pdf

override_dh_auto_build-arch:
	dh_auto_build -- all

override_dh_auto_build-indep:
	sed -i 's/REPLACEWITHDATE/$(PDF_DATE2)/' manual/presentation.tex
	PDF_DATE=$(PDF_DATE) dh_auto_build -- all manual

override_dh_auto_test:
ifeq (big,$(shell dpkg-architecture -qDEB_TARGET_ARCH_ENDIAN))
	dh_auto_test && { \
	  echo 'Big-endian arches are considered "unusably broken" by upstream and tests are'; \
	  echo 'expected to be broken. Despite this the tests seem to have succeeded, is it time'; \
	  echo 'to revise this expectation?'; \
	  echo "See https://github.com/YosysHQ/yosys/issues/2645"; \
	  echo "Failing build artificially."; \
	  exit 1; \
	}
else
	dh_auto_test
endif

=== debian/watch ===
version=4
https://github.com/YosysHQ/yosys/tags .*/yosys-([0-9.]+).tar.gz

## yosys 0.33

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,6 @@
 
 CONFIG := clang
 # CONFIG := gcc
-# CONFIG := gcc-4.8
 # CONFIG := afl-gcc
 # CONFIG := emcc
 # CONFIG := wasi
@@ -142,7 +141,7 @@
 endif
 endif
 
-YOSYS_VER := 0.23
+YOSYS_VER := 0.33
 
 # Note: We arrange for .gitcommit to contain the (short) commit hash in
 # tarballs generated with git-archive(1) using .gitattributes. The git repo
@@ -150,7 +149,7 @@
 # back to calling git directly.
 TARBALL_GIT_REV := $(shell cat $(YOSYS_SRC)/.gitcommit)
 ifeq ($(TARBALL_GIT_REV),$$Format:%h$$)
-GIT_REV := $(shell git ls-remote $(YOSYS_SRC) HEAD -q | $(AWK) 'BEGIN {R = "UNKNOWN"}; ($$2 == "HEAD") {R = substr($$1, 1, 9); exit} END {print R}')
+GIT_REV := $(shell GIT_DIR=$(YOSYS_SRC)/.git git rev-parse --short=9 HEAD || echo UNKNOWN)
 else
 GIT_REV := $(TARBALL_GIT_REV)
 endif
@@ -158,7 +157,7 @@
 OBJS = kernel/version_$(GIT_REV).o
 
 bumpversion:
-#	sed -i "/^YOSYS_VER := / s/+[0-9][0-9]*$$/+`git log --oneline f109fa3.. | wc -l`/;" Makefile
+#	sed -i "/^YOSYS_VER := / s/+[0-9][0-9]*$$/+`git log --oneline fbab08a.. | wc -l`/;" Makefile
 
 # set 'ABCREV = default' to use abc/ as it is
 #
@@ -166,7 +165,7 @@
 # is just a symlink to your actual ABC working directory, as 'make mrproper'
 # will remove the 'abc' directory and you do not want to accidentally
 # delete your work on ABC..
-ABCREV = ab5b16e
+ABCREV = bb64142
 ABCPULL = 1
 ABCURL ?= https://github.com/YosysHQ/abc
 ABCMKARGS = CC="$(CXX)" CXX="$(CXX)" ABC_USE_LIBSTDCXX=1 ABC_USE_NAMESPACE=abc VERBOSE=$(Q)
@@ -255,12 +254,6 @@
 ifeq ($(DISABLE_ABC_THREADS),1)
 ABCMKARGS += "ABC_USE_NO_PTHREADS=1"
 endif
-
-else ifeq ($(CONFIG),gcc-4.8)
-CXX = gcc-4.8
-LD = gcc-4.8
-CXXFLAGS += -std=$(CXXSTD) -Os
-ABCMKARGS += ARCHFLAGS="-DABC_USE_STDINT_H"
 
 else ifeq ($(CONFIG),afl-gcc)
 CXX = AFL_QUIET=1 AFL_HARDEN=1 afl-gcc
@@ -379,7 +372,7 @@
 EXE = .exe
 
 else ifneq ($(CONFIG),none)
-$(error Invalid CONFIG setting '$(CONFIG)'. Valid values: clang, gcc, gcc-4.8, emcc, mxe, msys2-32, msys2-64)
+$(error Invalid CONFIG setting '$(CONFIG)'. Valid values: clang, gcc, emcc, mxe, msys2-32, msys2-64)
 endif
 
 ifeq ($(ENABLE_LIBYOSYS),1)
@@ -387,3 +380,4 @@
 endif
 
 ifeq ($(ENABLE_PYOSYS),1)
+# Detect name of boost_python library. Some distros use boost_python-py<version>, other boost_python<version>, some only use the major version number, some a concatenation of major and minor version numbers

=== docs/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source

.PHONY: help
help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  applehelp  to make an Apple Help Book"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  epub3      to make an epub3"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  latexpdfja to make LaTeX files and run them through platex/dvipdfmx"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  xml        to make Docutils-native XML files"
	@echo "  pseudoxml  to make pseudoxml-XML files for display purposes"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"
	@echo "  coverage   to run coverage check of the documentation (if enabled)"
	@echo "  dummy      to check syntax errors of document sources"

.PHONY: clean
clean:
	rm -rf $(BUILDDIR)/*

.PHONY: html
html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

.PHONY: dirhtml
dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

# singlehtml section links are broken
.PHONY: singlehtml
singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

.PHONY: pickle
pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

.PHONY: json
json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

.PHONY: htmlhelp
htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

.PHONY: qthelp
qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/SymbiYosys.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/SymbiYosys.qhc"

.PHONY: applehelp
applehelp:
	$(SPHINXBUILD) -b applehelp $(ALLSPHINXOPTS) $(BUILDDIR)/applehelp
	@echo
	@echo "Build finished. The help book is in $(BUILDDIR)/applehelp."
	@echo "N.B. You won't be able to view it unless you put it in" \
	      "~/Library/Documentation/Help or install it in your application" \
	      "bundle."

.PHONY: devhelp
devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/SymbiYosys"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/SymbiYosys"
	@echo "# devhelp"

.PHONY: epub
epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

.PHONY: epub3
epub3:
	$(SPHINXBUILD) -b epub3 $(ALLSPHINXOPTS) $(BUILDDIR)/epub3
	@echo
	@echo "Build finished. The epub3 file is in $(BUILDDIR)/epub3."

.PHONY: latex
latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

.PHONY: latexpdf
latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

.PHONY: latexpdfja
latexpdfja:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through platex and dvipdfmx..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf-ja
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

.PHONY: text
text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

.PHONY: man
man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

.PHONY: texinfo
texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

.PHONY: info
info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

.PHONY: gettext
gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

.PHONY: changes
changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

.PHONY: linkcheck
linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

.PHONY: doctest
doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

.PHONY: coverage
coverage:
	$(SPHINXBUILD) -b coverage $(ALLSPHINXOPTS) $(BUILDDIR)/coverage
	@echo "Testing of coverage in the sources finished, look at the " \
	      "results in $(BUILDDIR)/coverage/python.txt."

.PHONY: xml
xml:
	$(SPHINXBUILD) -b xml $(ALLSPHINXOPTS) $(BUILDDIR)/xml
	@echo
	@echo "Build finished. The XML files are in $(BUILDDIR)/xml."

.PHONY: pseudoxml
pseudoxml:
	$(SPHINXBUILD) -b pseudoxml $(ALLSPHINXOPTS) $(BUILDDIR)/pseudoxml
	@echo
	@echo "Build finished. The pseudo-XML files are in $(BUILDDIR)/pseudoxml."

.PHONY: dummy
dummy:
	$(SPHINXBUILD) -b dummy $(ALLSPHINXOPTS) $(BUILDDIR)/dummy
	@echo
	@echo "Build finished. Dummy builder generates no files."

=== docs/source/requirements.txt ===
sphinx-press-theme
sphinxcontrib-bibtex

=== tests/unit/Makefile ===
GTESTFLAG := -lgtest -lgtest_main
RPATH := -Wl,-rpath
EXTRAFLAGS := -lyosys -pthreads

OBJTEST := objtest
BINTEST := bintest

ALLTESTFILE := $(shell find -name '*Test.cc' -printf '%P ')
TESTDIRS := $(sort $(dir $(ALLTESTFILE)))
TESTS := $(addprefix $(BINTEST)/, $(basename $(ALLTESTFILE:%Test.cc=%Test.o)))

# Prevent make from removing our .o files
.SECONDARY:

all: prepare $(TESTS) run-tests

$(BINTEST)/%: $(OBJTEST)/%.o
	$(CXX) -L$(ROOTPATH) $(RPATH)=$(ROOTPATH) -o $@ $^ $(LDLIBS) \
		$(GTESTFLAG) $(EXTRAFLAGS)

$(OBJTEST)/%.o: $(basename $(subst $(OBJTEST),.,%)).cc
	$(CXX) -o $@ -c -I$(ROOTPATH) $(CPPFLAGS) $(CXXFLAGS) $^

.PHONY: prepare run-tests clean

run-tests: $(TESTS)
	$(subst Test ,Test; ,$^)

prepare:
	mkdir -p $(addprefix $(BINTEST)/,$(TESTDIRS))
	mkdir -p $(addprefix $(OBJTEST)/,$(TESTDIRS))

clean:
	rm -rf $(OBJTEST)
	rm -rf $(BINTEST)

=== debian/changelog ===
yosys (0.33-5build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 15:53:45 +1100

yosys (0.33-5build1) noble; urgency=medium

  * No-change rebuild against libreadline t64.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 15 Mar 2024 19:03:28 +0100

yosys (0.33-5) unstable; urgency=medium

  * Fix pdflatex reproducibility

 -- Daniel Gröber <dxld@darkboxed.org>  Sat, 23 Sep 2023 21:58:59 +0200

yosys (0.33-4) unstable; urgency=medium

  * Fix autotest.sh patch locking again

 -- Daniel Gröber <dxld@darkboxed.org>  Wed, 06 Sep 2023 22:10:05 +0200

yosys (0.33-3) unstable; urgency=medium

  * Fix botched flock invocation in autotest fix

 -- Daniel Gröber <dxld@darkboxed.org>  Wed, 06 Sep 2023 15:26:27 +0200

yosys (0.33-2) unstable; urgency=medium

  * Fix text file busy due to autotest.sh gcc race
  * Fix superfluous-file-pattern in d/copyright

 -- Daniel Gröber <dxld@darkboxed.org>  Wed, 06 Sep 2023 11:04:15 +0200

yosys (0.33-1) unstable; urgency=medium

  * New upstream version 0.33
  * Add d/README.source documenting gbp import-orig invocation for MUT

 -- Daniel Gröber <dxld@darkboxed.org>  Wed, 06 Sep 2023 00:12:04 +0200

yosys (0.32-2) unstable; urgency=medium

  * Source-only upload to facilitate testing migration
  * Protect only latex from locale environment
  * Prevent rebuilding world with -nc due to patch unapplication

 -- Daniel Gröber <dxld@darkboxed.org>  Fri, 01 Sep 2023 13:37:09 +0200

yosys (0.32-1) unstable; urgency=medium

  * New upstream version 0.32
  * Use upstream's yosys-abc fork directly, dropping berkeley-abc depends

  * Standards version 4.6.2 - no changes (Steffen Möller)
  * d/rules sets LC_ALL and LANG to C to harden build (Steffen Möller)

 -- Daniel Gröber <dxld@darkboxed.org>  Sun, 27 Aug 2023 13:10:41 +0200

yosys (0.30-6) unstable; urgency=medium

  * Remove yosys-src (Closes: #1050397)

 -- Daniel Gröber <dxld@darkboxed.org>  Sat, 26 Aug 2023 17:53:00 +0200

yosys (0.30-5) unstable; urgency=medium

  * Fix yosys-testsuite autopkgtest failing due to stderr output
  * Clarify d/copyright declared licenses of debian/patches/
  * Fix superfluous-file-pattern lintian warning
  * yosys-testsuite: Check for right number of arguments
  * Remove yosys-tests package, not needed for abc autopkgtest blocking
  * yosys-testsuite: Replace Test-Command invocation with script

 -- Daniel Gröber <dxld@darkboxed.org>  Wed, 23 Aug 2023 16:40:01 +0200

yosys (0.30-4) unstable; urgency=medium

  * yosys-testsuite: Remove dh dependency for cleaning

 -- Daniel Gröber <dxld@darkboxed.org>  Wed, 23 Aug 2023 14:13:52 +0200

yosys (0.30-3) unstable; urgency=medium

  * Fix i386 excess-precicion issue in fstapi

 -- Daniel Gröber <dxld@darkboxed.org>  Tue, 22 Aug 2023 20:49:25 +0200

yosys (0.30-2) unstable; urgency=medium

  * Fix install of manual.pdf
  * Skip running tests for binary-indep (docs) build

 -- Daniel Gröber <dxld@darkboxed.org>  Tue, 22 Aug 2023 13:45:07 +0200

yosys (0.30-1) unstable; urgency=medium

  * Demote xdot to Recommends
  * Add patch to fix building with LTO (Closes: #1015712)
  * Enable LTO
  * New upstream version 0.30
  * Fix dsc build after binary build (Closes: #1047992)
  * Add autopkgtest for abc integration testing

  [ Steffen Möller while sponsoring ]
  * Removed d/gbp.conf debian-branch pointer to experimental.

 -- Daniel Gröber <dxld@darkboxed.org>  Fri, 18 Aug 2023 17:52:25 +0200

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: yosys
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Ruben Undheim <ruben.undheim@gmail.com>,
            Sebastian Kuzminsky <seb@highlab.com>,
            Daniel Gröber <dxld@darkboxed.org>
@@ -9,15 +10,17 @@
                dh-python,
                tcl-dev,
                libreadline-dev,
+               libbz2-dev,
+               zlib1g-dev,
                bison,
                flex,
                gawk,
+               git,
                libffi-dev,
                pkg-config,
                txt2man,
                iverilog (>= 10.1),
                python3,
-               berkeley-abc (>= 1.01+20221019git70cb339+dfsg-3)
 Build-Depends-Indep:
                texlive-base,
                texlive-plain-generic,
@@ -29,10 +32,16 @@
                texlive-science,
                texlive-publishers,
                texlive-bibtex-extra,
+               tex-gyre,
+               latexmk,
                lmodern,
-               graphviz
+               graphviz,
+               pdf2svg,
+               python3-sphinx,
+               python3-sphinx-press-theme,
+               python3-sphinxcontrib.bibtex
 Rules-Requires-Root: no
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/science-team/yosys
 Vcs-Git: https://salsa.debian.org/science-team/yosys.git
 Homepage: https://github.com/YosysHQ/yosys
@@ -43,8 +52,8 @@
          ${python3:Depends},
          python3-click,
          ${misc:Depends},
-         berkeley-abc (>= 1.01+20221019git70cb339+dfsg-3),
-         xdot
+         yosys-abc (>= 0.32-1),
+Recommends: xdot
 Description: Framework for Verilog RTL synthesis
  This is a framework for Verilog RTL synthesis. It currently has extensive
  Verilog-2005 support and provides a basic set of synthesis algorithms for
@@ -73,13 +82,29 @@
  .
  This package contains the headers and programs needed to build yosys plugins.
 
+Package: yosys-abc
+Architecture: any
+Depends: ${shlibs:Depends},
+         ${misc:Depends},
+Replaces: yosys (<< 0.32-1)
+Breaks: yosys (<< 0.32-1)
+Description: Sequential Logic Synthesis and Verification Algorithms
+ ABC is a system for synthesis and verification of binary sequential logic
+ circuits appearing in synchronous hardware designs. It combines scalable
+ logic optimization based on And-Inverter Graphs (AIGs), optimal-delay
+ DAG-based technology mapping for look-up tables and standard cells, and
+ innovative algorithms for sequential synthesis and verification.
+ .
+ This is a fork of berkeley-abc maintained by the YosysHQ team for use in
+ the yosys RTL synthesis framework.
+
 Package: yosys-doc
 Section: doc
 Architecture: all
 Depends: ${misc:Depends}
 Multi-Arch: foreign
 Suggests: yosys
-Description: Documentation for Yosys
+Description: Framework for Verilog RTL synthesis (documentation)
  Yosys is a framework for Verilog RTL synthesis. It currently has extensive
  Verilog-2005 support and provides a basic set of synthesis algorithms for
  various application domains.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

include /usr/share/dpkg/pkg-info.mk

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=+lto

%:
	PREFIX=/usr dh $@ --with=python3

execute_after_dh_auto_clean:
	$(RM) debian/man/*.1

        # Remove gitignore'd files
	git --git-dir=debian/git-repo init
	git --git-dir=debian/git-repo --work-tree=. clean -Xdf \
		-e '!/abc' \
		-e '!/tests/simple_abc9/abc9.v'
	rm -rf debian/git-repo

	rm -f abc/abc-*

	# Help with transition from earlier versions of this package
	rm -rf debian/yosys-src.substvars debian/yosys-src/
	rm -rf debian/yosys-tests.substvars debian/yosys-tests/


override_dh_auto_configure:
	printf '%s\n' \
	  'CONFIG := gcc' \
	  'ABCPULL=0' \
	  'STRIP=:' \
	  > Makefile.conf

execute_after_dh_auto_install:
	chmod a-x debian/tmp/usr/share/yosys/achronix/speedster22i/cells*.v

execute_before_dh_installman:
	cd debian/man ; CHANGELOG_DATE="$(CHANGELOG_DATE)" ./genmanpages.sh

override_dh_compress:
	dh_compress --exclude=.pdf

override_dh_auto_build-arch:
	dh_auto_build -- all

override_dh_auto_build-indep: export LC_ALL=C.UTF-8
override_dh_auto_build-indep: export FORCE_SOURCE_DATE=1
override_dh_auto_build-indep:
	dh_auto_build -- docs DOC_TARGET=latexpdf
	+cd manual/ && ./presentation.sh

override_dh_auto_test-indep: # no tests for docs

override_dh_auto_test-arch:
ifeq (big,$(shell dpkg-architecture -qDEB_TARGET_ARCH_ENDIAN))
	dh_auto_test -- PATH="$$PWD:$$PATH" && { \
	  echo 'Big-endian arches are considered "unusably broken" by upstream and tests are'; \
	  echo 'expected to be broken. Despite this the tests seem to have succeeded, is it time'; \
	  echo 'to revise this expectation?'; \
	  echo "See https://github.com/YosysHQ/yosys/issues/2645"; \
	  echo "Failing build artificially."; \
	  exit 1; \
	}
else
	dh_auto_test -- PATH="$$PWD:$$PATH"
endif

=== debian/tests/control ===
Tests: yosys-testsuite
Depends:
 yosys, yosys-dev,
 gcc, g++,
 gawk,
 iverilog,
 pkg-config,
 tcl
Restrictions: allow-stderr, rw-build-tree

Tests: ice, smtbc
Depends: yosys

=== debian/watch ===
version=4
https://github.com/YosysHQ/yosys/tags .*/yosys-([0-9.]+).tar.gz

opts=\
component=abc,\
filenamemangle=s/yosys-([0-9.]+)\.tar\.gz/yosys-abc-$1.tar.gz/ \
https://github.com/YosysHQ/abc/tags .*/yosys-([0-9.]+).tar.gz same

## yosys 0.51

=== debian/changelog ===
yosys (0.51-1) unstable; urgency=medium

  * New upstream version 0.51

 -- Daniel Gröber <dxld@darkboxed.org>  Tue, 18 Mar 2025 00:00:57 +0100

yosys (0.49-1) unstable; urgency=medium

  [ Scott Ashcroft ]
  * New upstream release (Closes: #1068174)
  * Fix Build-Depends (Closes: #1055408, #1080844)
  * Presentation was removed upstream. (Closes: #1093368)

  [ Daniel Gröber ]
  * Add patch to replace rsync with cp in build
  * Add patch to properly invalidate docs generated help on failure

  [ Scott Ashcroft ]
  * Replace additional rsync usage with cp
  * Don't install python cache files

 -- Daniel Gröber <dxld@darkboxed.org>  Sun, 16 Mar 2025 16:03:14 +0100

yosys (0.33-6) unstable; urgency=medium

  * Incorporate changes from experimental.

 -- Daniel Gröber <dxld@darkboxed.org>  Mon, 06 Jan 2025 16:48:42 +0100

yosys (0.33-6~exp3) experimental; urgency=medium

  * Fix SOURCE_DATE_EPOCH_FAKETIME not using UTC with date -u
  * Add patch fixing docs/images "tidy" race (Closes: #1052902, #1069424)

 -- Daniel Gröber <dxld@darkboxed.org>  Fri, 04 Oct 2024 21:14:00 +0200

yosys (0.33-6~exp2) experimental; urgency=medium

  * Override TZ to make docs reproducible

 -- Daniel Gröber <dxld@darkboxed.org>  Thu, 02 Nov 2023 11:01:21 +0100

yosys (0.33-6~exp1) experimental; urgency=medium

  * Revert to using faketime for graphviz/dot reproducibility

 -- Daniel Gröber <dxld@darkboxed.org>  Wed, 18 Oct 2023 17:12:31 +0200

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: yosys
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Ruben Undheim <ruben.undheim@gmail.com>,
            Sebastian Kuzminsky <seb@highlab.com>,
            Daniel Gröber <dxld@darkboxed.org>
@@ -17,10 +16,13 @@
                gawk,
                git,
                libffi-dev,
-               pkg-config,
+               pkgconf,
                txt2man,
-               iverilog (>= 10.1),
+               iverilog (>= 12),
                python3,
+               python3-setuptools,
+               libcxxopts-dev,
+               gtkwave
 Build-Depends-Indep:
                texlive-base,
                texlive-plain-generic,
@@ -36,10 +38,12 @@
                latexmk,
                lmodern,
                graphviz,
+               faketime,
                pdf2svg,
                python3-sphinx,
                python3-sphinx-press-theme,
-               python3-sphinxcontrib.bibtex
+               python3-sphinxcontrib.bibtex,
+               python3-click,
 Rules-Requires-Root: no
 Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/science-team/yosys
